<?php

namespace Drupal\wkhtmltopdf\Form;

use \Drupal\Core\Form\ConfigFormBase;
use \Symfony\Component\DependencyInjection\ContainerInterface;
use \Drupal\Core\Config\ConfigFactoryInterface;
use \Drupal\Core\Form\FormStateInterface;

class WkhtmltopdfConfig extends ConfigFormBase {

  protected function getEditableConfigNames() {
    return [
      'wkhtmltopdf.settings'
    ];
  }

  public function getFormId() {
    return 'wkhtmltopdf_admin_settings';
  }


  public function __construct(ConfigFactoryInterface $config_factory) {
    parent::__construct($config_factory);
  }

  public static function create(ContainerInterface $container) {
    return parent::create($container); // TODO: Change the autogenerated stub
  }

  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('wkhtmltopdf.settings');
    $form['wkhtmltopdf_bin'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Path to binary'),
      '#description' => $this->t('Path to wkhtmltopdf binary'),
      '#default_value' => $config->get('wkhtmltopdf_bin'),
    ];

    $form['wkhtmltopdf_zoom'] = [
      '#type' => 'number',
      '#title' => $this->t('Zoom'),
      '#description' => $this->t('Zoom page'),
      '#default_value' => $config->get('wkhtmltopdf_zoom'),
      '#step' => '0.1',
    ];

    return parent::buildForm($form, $form_state);
  }

  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

    $this->configFactory->getEditable('wkhtmltopdf.settings')
      ->set('wkhtmltopdf_bin', $form_state->getValue('wkhtmltopdf_bin'))
      ->set('wkhtmltopdf_zoom', $form_state->getValue('wkhtmltopdf_zoom'))
      ->save();

    parent::submitForm($form, $form_state);
  }

}
